/*
 *      arbitrage2.C
 *      
 *      Copyright 2010 Contest team 23 <cteam23@pc-7-32>
 *      
 */


#include <iostream>
#include <string>
#include <sstream>
#include <vector>

using namespace std;

struct Node;

vector<Node*> nodes;

struct Node{
	string menaA, menaB;
	int kurzA, kurzB;
	float value;
	bool visited;
	bool arbitrage;
	
	void init(){
		value = 0;
		visited = false;
		arbitrage = false;
	}
	
	Node(string menaA, string menaB, int kurzA, int kurzB){
		this->menaA = menaA;
		this->menaB = menaB;
		this->kurzA = kurzA;
		this->kurzB = kurzB;		
	}
	
	Node* getSomeAdjacent(){
		for(int i = 0; i < nodes.size(); i++){
			Node * node = nodes[i];
			
			if (menaB == node->menaA) {
				return node;
			}			
		}
		return 0L;
	}
	
	bool process(){
		return dfs(1.0, menaA);
	}
	
	bool dfs(float value, string &mena){
		this->visited = true;
		this->value = value * (kurzB / kurzA);
		
		if (menaB.compare(mena) == 0){
			if (value > 1) arbitrage = true;
			return arbitrage;
		}	
		
		for(int i = 0; i < nodes.size(); i++){
			Node * node = nodes[i];
	
			if (menaB.compare(node->menaA) == 0 && node->visited == false) {
				if (node->dfs(this->value, mena)) return true;
			}
		}
		return arbitrage;
	}
};

inline void initAllNodes(){
	for(int i = 0; i < nodes.size(); i++){
		nodes[i]->init();
	}
}

inline int strToInt(string str){
	istringstream iss(str);

	int out;	
	iss >> out;
	return out;
}

int main(int argc, char** argv)
{
		char line[256];
		int count, pairs;
		string a,b;
		string kurz;
		int pos;
		int kurzA, kurzB;

		while(1){
		fgets(line, sizeof(line), stdin);		
		sscanf(line, "%d", &count);
		
		if (count == 0) break;
		
		//for (int i = 0; i < count; i++){
			//kurzy[i] = 0;
		//}
		
		fgets(line, sizeof(line), stdin);
		istringstream iss(line);
		
		//for (int i = 0; i < count; i++){				
				//iss >> meny[i];
		//}
		
		fgets(line, sizeof(line), stdin);		
		sscanf(line, "%d", &pairs);
		
		//cout << pairs << endl;
		
		for (int i = 0; i < pairs; i++){
			
				//cout << pairs << endl;
				
				fgets(line, sizeof(line), stdin);
				istringstream iss(line);			
				
				iss >> a;
				iss >> b;
				
				iss >> kurz;
				
				//aPos = findInArray(a, count);
				//bPos = findInArray(b, count);
				
				//pozice dvojtecky
				pos = kurz.find(":");
				
				kurzA = strToInt(kurz.substr(0,pos));
				kurzB = strToInt(kurz.substr(pos + 1, kurz.size() - pos +1));
				
				nodes.push_back(new Node(a, b, kurzA, kurzB));
		}
		
		bool arbitrage = false;
		
		for(int i = 0; i < nodes.size(); i++){
			initAllNodes();
			Node * node = nodes[i];
			
			if (node->process()) {
				arbitrage = true;
				break;
			}
		}
		
		if (arbitrage) printf("Ok\n");
		else printf("Arbitrage\n");
	}
	
	
	return 0;
}
